package com.burtbeckwith.dynamicdomain

import java.security.CodeSource

import org.codehaus.groovy.control.CompilationUnit
import org.codehaus.groovy.control.CompilerConfiguration
import org.codehaus.groovy.control.Phases
import org.codehaus.groovy.grails.commons.ApplicationHolder
import org.codehaus.groovy.grails.compiler.injection.ClassInjector
import org.codehaus.groovy.grails.compiler.injection.GrailsAwareClassLoader
import org.codehaus.groovy.grails.compiler.injection.GrailsAwareInjectionOperation

/**
 * Uses a custom injector.
 *
 * @author <a href='mailto:burt@burtbeckwith.com'>Burt Beckwith</a>
 */
class DynamicClassLoader extends GrailsAwareClassLoader {

	private final ClassInjector[] _classInjectors = [new DynamicDomainClassInjector()]

	DynamicClassLoader() {
		super(ApplicationHolder.application.classLoader, CompilerConfiguration.DEFAULT)
		classInjectors = _classInjectors
	}

	@Override
	protected CompilationUnit createCompilationUnit(CompilerConfiguration config, CodeSource source) {
		CompilationUnit cu = super.createCompilationUnit(config, source)
		cu.addPhaseOperation(new GrailsAwareInjectionOperation(
			getResourceLoader(), _classInjectors), Phases.CANONICALIZATION)
		cu
	}
}
